<?php

if (!defined('_PS_VERSION_'))
    exit;

class Export
{
    public $delimiter = '|';

        public $id_shop;
        public $export_shop_file_names;
        public $export_shop_uri;
        public $file_path;

        public function __construct($id_shop, $base_path = null){
            $this->id_shop=$id_shop;
            if(empty($base_path)){
                $base_path = _PS_ROOT_DIR_.'/';
            }else{
                if(preg_match('/'.str_replace('/','\/',_PS_ROOT_DIR_).'/', $base_path)){
                     $base_path = $base_path;
                }else{
                      $base_path = _PS_ROOT_DIR_.'/'.$base_path;
                }
            }

            $this->file_path = $base_path;
        }



    public function exportProductsShop($id_shop = null, $debug_log = false)
    {
        if ($debug_log) {
            $flog = fopen("export_log.txt", "a+");
            fwrite (
                $flog,
                'Export logging started on ' . date("Y.m.d h:i:s") . PHP_EOL
                );
        }

        $product_id_type = Configuration::get('PSWIDGET_PRODUCT_ID_TYPE');

        if ($debug_log) {
            fwrite (
                $flog,
                'Product ID type: ' . json_encode($product_id_type) . PHP_EOL
                );
        }

        if(empty($id_shop)){
            $id_shop = $this->id_shop;
        }

        if(!is_array($id_shop)){
            $id_shop = array();
            $id_shop[] = $id_shop;
        }

        foreach ($id_shop as $id_sho){

            if ($debug_log) {
                fwrite (
                    $flog,
                    '--- Start Shop ' . json_encode($id_sho) . ' ---' . PHP_EOL
                    );
            }

            $subqueries = array(
                'names' => 'select concat( "ifnull(group_concat(distinct if(pl.id_lang=\'", la.id_lang, "\' repIdShop, pl.name, null) ),\'\') as ",
                            concat("title_",iso_code), ",") as expr from '._DB_PREFIX_.'lang la '
                            . 'left join ' ._DB_PREFIX_. 'lang_shop as las ON la.id_lang = las.id_lang WHERE las.id_shop = ' . $id_sho,
                'desc' => 'select concat( "ifnull(group_concat(distinct if(pl.id_lang=\'", la.id_lang, "\' repIdShop, pl.description, null) ),\'\') as ",
                            concat("description_",iso_code), ",") as expr from '._DB_PREFIX_.'lang la '
                            . 'left join ' ._DB_PREFIX_. 'lang_shop as las ON la.id_lang = las.id_lang WHERE las.id_shop = ' . $id_sho,
                'urls' => 'select concat( "ifnull(group_concat(distinct if(pl.id_lang=\'", la.id_lang, \' repIdShop\',  concat("\', concat(\''._PS_BASE_URL_.__PS_BASE_URI__
                            .'\',\'",iso_code,"/\',p.id_product,\'-\',pl.link_rewrite,\'.html\'), null) ),\'\') as "), concat("url_",iso_code), ",") as expr from ' ._DB_PREFIX_.'lang la '
                            . 'left join ' ._DB_PREFIX_. 'lang_shop as las ON la.id_lang = las.id_lang WHERE las.id_shop = ' . $id_sho,
                'prices' => 'select concat( "IFNULL(psh.price, p.price) *", conversion_rate, " as ", concat("price_",lower(iso_code)), ",") as expr from '._DB_PREFIX_.'currency'
                );

            $subquery_str = '';

            foreach ($subqueries as $query)
            {
                foreach (Db::getInstance()->ExecuteS($query) as $res)
                    $subquery_str .= $res['expr'];
            }

            $subquery_str = rtrim($subquery_str, ',');

            $id_shop_group = Shop::getGroupFromShop($id_sho);
            $query = 'select share_stock from '._DB_PREFIX_.'shop_group where id_shop_group='.$id_shop_group;
            $share_stock = Db::getInstance()->getValue($query);

            if($share_stock){
                $query = 'select p.id_product as sku, p.id_product as sku_copy, p.ean13 as ean13, p.upc as upc, p.reference, IFNULL(psh.id_category_default, p.id_category_default) AS product_types, if(sp.id_product = p.id_product AND sp.id_shop IN(0, '.$id_sho.'), 1, 0) as on_sale, if(ps.quantity > 0, \'in stock\',\'out of stock\') as in_stock, pl.link_rewrite, IFNULL(psh.price, p.price) as price,'.str_replace('repIdShop', ' AND pl.id_shop = ' .$id_sho, $subquery_str)
                    .', if(sp.id_product = p.id_product AND sp.id_shop IN(0, '.$id_sho.'), 1, 0) as on_sale'
                    .' from '._DB_PREFIX_.'product p '
                    .'left join '._DB_PREFIX_.'product_lang pl ON p.id_product = pl.id_product'
                    .' left join '._DB_PREFIX_.'stock_available ps ON p.id_product = ps.id_product AND ps.id_product_attribute=0 '
                    .'left join '._DB_PREFIX_.'product_shop psh ON p.id_product = psh.id_product AND psh.id_shop = '.$id_sho
                    .' left join '._DB_PREFIX_.'specific_price sp ON p.id_product = sp.id_product'
                    .' where ( psh.active = 1 AND psh.visibility <> "none" ) group by p.id_product';

            }else{
                $query = 'select p.id_product as sku, p.id_product as sku_copy, p.ean13 as ean13, p.upc as upc, p.reference, if(ps.quantity > 0, \'in stock\',\'out of stock\') as in_stock, pl.link_rewrite, IFNULL(psh.price, p.price) as price,'.str_replace('repIdShop', ' AND pl.id_shop = '.$id_sho, $subquery_str)
                    .', IFNULL(psh.id_category_default, p.id_category_default) AS product_types, if(sp.id_product = p.id_product AND sp.id_shop IN(0, '.$id_sho.'), 1, 0) as on_sale'
                    .' from '._DB_PREFIX_.'product p '
                    .'left join '._DB_PREFIX_.'product_lang pl ON p.id_product = pl.id_product'
                    .' left join '._DB_PREFIX_.'stock_available ps ON p.id_product = ps.id_product AND ps.id_product_attribute=0 AND ps.id_shop='.$id_sho
                    .' left join '._DB_PREFIX_.'product_shop psh ON p.id_product = psh.id_product AND psh.id_shop='.$id_sho
                    .' left join '._DB_PREFIX_.'specific_price sp ON p.id_product = sp.id_product'
                    .' where ( psh.active = 1 AND psh.visibility <> "none" ) group by p.id_product';
            }

            if ($debug_log) {
                fwrite (
                    $flog,
                    'Export SQL query: ' . PHP_EOL . json_encode($query) . PHP_EOL
                    );
            }

            $rows = Db::getInstance()->ExecuteS($query);

            $csv_headers = array_keys($rows[0]);

            if ($debug_log) {
                fwrite (
                    $flog,
                    'Initial CSV Headers: (' . count($csv_headers) . ')' . PHP_EOL . json_encode($csv_headers) . PHP_EOL
                    );
            }

            $csv_headers[] = 'image_url';

            $fields_export_excess = array('sku_copy', 'ean13', 'upc', 'link_rewrite', 'reference', 'price');

            foreach ($fields_export_excess as $field)
            {
                    if (($key = array_search($field, $csv_headers)) !== false)
                            unset($csv_headers[$key]);
            }

            $pattern = '(title_|description|url_)';

            foreach ($csv_headers as $key=>$value) {
                if (preg_match($pattern, $value)) {
                    $csv_headers[$key] = $value . '_' . $id_sho;
                }
            }

            if ($debug_log) {
                fwrite (
                    $flog,
                    'CSV Headers (Processed): (' . count($csv_headers) . ')' . PHP_EOL . json_encode($csv_headers) . PHP_EOL
                    );
            }

            $langRows = Db::getInstance()->ExecuteS(
                'select la.id_lang, la.iso_code from '._DB_PREFIX_.'lang la '
                . 'left join ' ._DB_PREFIX_. 'lang_shop as las ON la.id_lang = las.id_lang WHERE las.id_shop = ' . $id_sho);

            if ($debug_log) {
                fwrite (
                    $flog,
                    'Language rows: (' . count($csv_headers) . ')' . PHP_EOL . json_encode($langRows) . PHP_EOL
                    );
            }

            $export_filename = 'ps_photoslurp_export_shop'.$id_sho.'.csv';

            if ($debug_log) {
                fwrite (
                    $flog,
                    'Filename: ' . json_encode($export_filename) . PHP_EOL
                    );
            }

            if(!file_exists($this->file_path)){
                mkdir($this->file_path,0777,TRUE);
            }

            $exportUri = $this->file_path.$export_filename;
            $fp = fopen($exportUri, 'w+');

            if ($debug_log) {
                fwrite (
                    $flog,
                    'Export URI: ' . json_encode($exportUri) . PHP_EOL
                    );
            }


            fwrite($fp, '# exported at ' . date('d-m-Y') . ' v 3.1.1 prestashop '._PS_VERSION_  . PHP_EOL);
            fputcsv($fp, $csv_headers, $this->delimiter);
            $linkObj = new Link();
            $pattern = '/"/';
            $replacement = '$0"';

            foreach ($rows as $row_index=>$row){
                $id_product = $row['sku'];
                if ($product_id_type) {
                    $row['sku'] = $row[$product_id_type];
                }

                $id_category = $row['product_types'];
                $cat = new Category($id_category);

                $category_bread = array();
                $categories = Db::getInstance()->executeS('SELECT * FROM '._DB_PREFIX_.'category_product WHERE id_product = '.$id_product.' ORDER BY position');

                $languages = Language::getLanguages(false);
                foreach ($languages as $lang){
                    foreach($categories as $category){
                        $brands = $this->getCategoryBreadcrumb($category['id_category'], $lang['id_lang']);
                        if(!empty($brands)){
                            $category_bread[] = $brands;
                        }
                    }
                }
                $category_bread = array_unique($category_bread);
                $row['product_types'] = implode(",", $category_bread);

                $imageCover = Image::getCover($row['sku_copy']);
                $image_url = $linkObj->getImageLink($row['link_rewrite'], $imageCover['id_image'], ImageType::getFormatedName('large'));
                $row['image_url'] = $image_url;

                if ($debug_log) {
                    fwrite ($flog,'--- Start Language rows ---' . PHP_EOL);
                }

                foreach($langRows as $langRow){
                    $key = 'title_'.$langRow['iso_code'];
                    $row[$key]= sprintf('"%s"', preg_replace($pattern,$replacement,$row[$key]));

                    if ($debug_log) {
                        fwrite (
                            $flog,
                            'Key: ' . $key . PHP_EOL .
                            'Value: ' . $row[$key] . PHP_EOL);
                    }

                    $key = 'description_'.$langRow['iso_code'];
                    $row[$key]= sprintf('"%s"', preg_replace($pattern,$replacement,$row[$key]));

                    if ($debug_log) {
                        fwrite (
                            $flog,
                            'Key: ' . $key . PHP_EOL .
                            'Value: ' . $row[$key] . PHP_EOL);
                    }

                    $key = 'url_'.$langRow['iso_code'];
                    $row[$key] = $linkObj->getProductLink(new Product($row['sku_copy'],false,$langRow['id_lang'],$id_sho),null,$cat->link_rewrite[$langRow['id_lang']],null,$langRow['id_lang'],$id_sho);

                    if ($debug_log) {
                        fwrite (
                            $flog,
                            'Key: ' . $key . PHP_EOL .
                            'Value: ' . $row[$key] . PHP_EOL .
                            '--- End Language rows ---' . PHP_EOL);
                    }

                }

                    if ($debug_log && $row_index < 1 ) {
                        fwrite (
                            $flog,
                            '--- Start Product rows ---' . PHP_EOL .
                            json_encode($row) . PHP_EOL .
                            '--- End Product rows ---' . PHP_EOL);
                    }

                    foreach ($fields_export_excess as $field){
                        unset($row[$field]);
                    }

                    fwrite ($fp, implode($row, $this->delimiter) . PHP_EOL);

            }

            fclose($fp);

            if ($debug_log) {
                fwrite (
                    $flog,
                    '--- End Shop ' . json_encode($id_sho) . ' ---'  . PHP_EOL . PHP_EOL
                    );
            }

            $this->export_shop_uri[$id_sho] = $exportUri;
            $this->export_shop_file_names[$id_sho] = $export_filename;

        }

        if ($debug_log) {
            fclose($flog);
        }

    }

        public function getCategoryBreadcrumb($id_category, $id_lang){


            $context = Context::getContext();
            $path='';
            $pipe = '>';
            $full_path = '';

            $id_category = (int)$id_category;
            if ($id_category == 1) {
                return $path;
            }

            $interval = Category::getInterval($id_category);

            $id_root_category = $context->shop->getCategory();
            $interval_root = Category::getInterval($id_root_category);

            if ($interval) {
                $sql = 'SELECT c.id_category, cl.name, cl.link_rewrite
                                                FROM '._DB_PREFIX_.'category c
                                                LEFT JOIN '._DB_PREFIX_.'category_lang cl ON (cl.id_category = c.id_category'.Shop::addSqlRestrictionOnLang('cl').')
                                                '.Shop::addSqlAssociation('category', 'c').'
                                                WHERE c.nleft <= '.$interval['nleft'].'
                                                        AND c.nright >= '.$interval['nright'].'
                                                        AND c.nleft >= '.$interval_root['nleft'].'
                                                        AND c.nright <= '.$interval_root['nright'].'
                                                        AND cl.id_lang = '.(int)$id_lang.'
                                                        AND c.active = 1
                                                        AND c.level_depth > '.(int)$interval_root['level_depth'].'
                                                ORDER BY c.level_depth ASC';
                $categories = Db::getInstance()->executeS($sql);

                $n = 1;
                $n_categories = count($categories);
                foreach ($categories as $category) {
                    $full_path .= htmlentities($category['name'], ENT_NOQUOTES, 'UTF-8').(($n++ != $n_categories || !empty($path)) ? $pipe : '');
                }

                return $full_path.$path;
            }

        }

        public function getChecked_files($file = null){
            $this->context = Context::getContext();
            $return = array();
            if(empty($file)){
                    $file = $this->export_shop_uri;
                }
                if(!is_array($file)){
                    $file[] = $file;
                }

                foreach ($file as $key => $fil){
                    if(file_exists($fil)){
                           $return[$key]['uri'] = $fil;

                           $url = preg_replace('/'. str_replace('/','\/',_PS_ROOT_DIR_).'/',Tools::getHttphost(true), $fil);
                           $name = preg_replace('/'. str_replace('/','\/',$this->file_path).'/','', $fil);

                           $return[$key]['url'] = $url;
                           $return[$key]['name'] = $name;
                           $id_shop = preg_replace('/[^0-9]+/', '', $name);
                           $shop = new Shop($id_shop, $this->context->language->id);
                           $return[$key]['shop_name'] = $shop->name;

                    }
                }

                return $return;
        }

        public function getCsvFiles($path = null){

           if(empty($path)){
               $path=$this->file_path;
           }
            if (file_exists($path)) {
                $ficheros  = scandir($path);
                foreach($ficheros as $fi){
                    if($fi!='.' && $fi!='..'){
                        $shop = preg_replace('/[^0-9]+/', '', $fi);

                        $fichero[$shop]=$path.$fi;
                    }
                }
            }else{
                return false;
            }

            if(!isset($fichero)){
                return false;
            } else {
                return $fichero;
            }
        }




}
